	;
	; fire - johan
	; 
	; First version: 1996.09.26
	;
	
	include	'd:\src\nocrew10\56k\equates.asm'
	include	'd:\src\nocrew10\56k\macros.asm'
	
	
	org	p:0
	jmp	<start
	
	org	p:64
	
start	move	#-1,m0		; Set linear addressing for all registers
	move	#-1,m1
	move	m0,m2
	move	m0,m3
	move	m0,m4
	move	m0,m5
	move	m0,m6
	move	m0,m7
		
	ori	#3,mr		; Disable IPL0, 1 and 2
;	move	#2,omr		; Enable ROM
	move	#0,omr		; Disable ROM
	movep	#1,x:<<PBC		; Turn on Host Port
	movep	#0,x:<<HCR		; Turn off XMT and RCV interrupts

;******************** MAKE PALETTE ********************
	
	move	#<palette,r0	; Make fire palette
	clr	a
	move	#>2048,x0		; Red
	move	#>32,x1		; Green
	move	#>1,y0		; Blue
	do	#32,seg1		; Segment 1
	rep	#8
	move	a1,x:(r0)+
	add	y0,a
seg1	sub	y0,a
	do	#32,seg2		; Segment 2
	rep	#8
	move	a1,x:(r0)+
	add	x0,a
	sub	y0,a
seg2	sub	x0,a
	add	y0,a
	do	#64,seg3		; Segment 3
	rep	#8
	move	a1,x:(r0)+
	add	x1,a
seg3

;******************** CLEAR SCREEN ********************

	move	#<screen,r7
	move	#>160*100+2,y1
	clr	a
	do	y1,clear
	move	a,y:(r7)+
clear

;******************** SYNC WITH CPU ********************

	move	#>2,x0
	host_xmt	x:magic
syncCPU	host_rcv	a
	cmp	x0,a
	jne	syncCPU
	


;******************** FIRE ********************
	
next_frame	
	; get image
	
	move	#<screen+1,r1
	
	host_rcv	b		; rle words
	tst	b
	jeq	im_loop		; 0 in do loop loops 65536 times!!
	
	clr	a	#>$FF,x1
	do	b1,im_loop
	host_rcv	x0		; rle word
	
	tst	a	x0,n1	; skip
	jne	<im_put
	lua	(r1)+n1,r1
	jmp	im_next

im_put	rep	x0		; draw
	move	a,y:(r1)+

im_next	eor	x1,a		; toggle bits
im_loop
	
	; the effect!!
	
	move	#>15840,y1
	move	#<palette,r0
	move	#1023,m0
	move	#HRX,r3
	
	move	#screen+160*100-2+1,r4
	move	#screen+160*99-1+1,r5
	move	#screen+160*100+1,r6
;	move	#screen+160*100-1+1,r7
	
	do	y1,fireloop
	
	; Scrolls to fast
	
	;     (r5)
	; (r4)(r7)(r6)
	
;	move		y:(r4)-,a
;	move		y:(r5),y0
;	add	y0,a	y:(r6)-,y0
;	add	y0,a	y:(r7)-,y0
;	add	y0,a
;	lsr	a	a,n0
;	lsr	a	
;	move		x:(r0+n0),x0
	
;	sync_xmt
;	move		x0,x:(r3)	a,y:(r5)-

	; Looks uglier but scrolls slower.

	;     (r5)*2
	; (r4)      (r6)
	
	move		y:(r4)-,a
	move		y:(r6)-,y0
	add	y0,a	y:(r5),y0
	add	y0,a
	add	y0,a
	lsr	a	a,n0
	lsr	a	
	move		x:(r0+n0),x0

	sync_xmt
	move		x0,x:(r3)	a,y:(r5)-



fireloop
	jmp	<next_frame


;****************************************

	org	x:0

palette	ds	1024	
magic	dc	$000001	

	org	y:0

screen	ds	160*100+2
