	;
	; julia morphing, note: modified code from some french guy.
	;

	
juliaSyncRx:MACRO
	btst.b	#0,(a6)
	beq.s	*-4
	ENDM	
	
juliaSyncTx:MACRO
	btst.b	#1,(a6)
	beq.s	*-4
	ENDM	
	
juliaDelay:	MACRO
	move.w	\1,d0
	bsr.w	vsync
	dbra	d0,*-4
	ENDM
	
juliaWidth	EQU	100
juliaHeight	EQU	100
juliaSize	EQU	200*100*2
	
juliaDep_X	equ	-4194304		; -2/4 * 2^23
juliaDep_Y	equ	-4194304		; -2/4 * 2^23
juliaIncr	equ	84733		; 2/49.5/4 * 2^23
juliaC_Re	equ	-1310720+3000*100	; -0.625/4 * 2^23
juliaC_Im	equ	-1310720-10500*100	; -0.625/4 * 2^23
	
juliaFrames		equ	400
juliaColours	equ	31
	

julia:	lea	vga_100_200_hi(pc),a6	; Set video mode
	bsr.w	new_video_mode
	
	lea	juliaCst_Re(pc),a2
	
	lea	juliaDspBeg(pc),a0
	Dsp_ExecProg	a0,#(juliaDspEnd-juliaDspBeg)/3,#8001
	move.b	#%10000000,ICR.w	; Init host port
	
	movea.w	#RXU,a4		; Host Port registers
	movea.w	#RXM,a5
	movea.w	#ISR,a6
	
	moveq	#juliaColours,d2	; Fade register
	move.w	#juliaFrames,d3	; Number of frames
	
juliaLoop:	sub.l	#3000,(a2)		; juliaCst_Re
	add.l	#10500,(4.b,a2)	; juliaCst_Im
	
	juliaSyncTx
	move.l	#juliaDep_X,(a4)	; Send information to the DSP
	move.l	#juliaDep_Y,(a4)
	move.l	#juliaIncr,(a4)
	move.l	juliaCst_Re(pc),(a4)
	move.l	juliaCst_Im(pc),(a4)
	move.l	d2,(a4) 
	
	bsr.w	get_vb
	move.l	(vblist,d0.l*4),a0
	move.l	a0,a1
	add.l	#juliaSize,a1
	
	move.w	#(juliaWidth*juliaHeight/2)-1,d5
	
	bra.w	juliaRecLoop
	.long
	
	
juliaRecLoop:
	juliaSyncRx			; Get julia from dsp
	move.w	(a5),d6
	move.w	d6,(a0)+
	move.w	d6,(a0)+
	move.w	d6,-(a1)
	move.w	d6,-(a1)
	dbra	d5,juliaRecLoop
	
	bsr.w	insert_vb		; # in d0
	
	subq.w	#1,d3
	ble.s	julia2
	cmp.w	#juliaFrames-juliaColours,d3
	blt.s	julia1
	subq.w	#1,d2
	bra.w	juliaLoop
julia1:	cmp.w	#juliaColours,d3
	bgt.w	juliaLoop
	addq.w	#1,d2
	bra.w	juliaLoop

julia2:	rts	
	
		
	section	data
	
juliaCst_Re:	dc.l	juliaC_Re
juliaCst_Im:	dc.l	juliaC_Im

juliaDspBeg:	incbin	e_julia\dsp.dsp
juliaDspEnd:	
	.long
	
	section	text
