	;
	; nocrew10 demo
	; 
	
	;opt	p+
	
	section	text
	
	include	68k\equates.s
	include	68k\stmacros.s
	include	68k\fmacros.s
   	include	68k\jbmacros.s
	
	
	Super	#0		; Enter supervisor mode
	bsr.w	save_all
	
	moveq	#$11,d0		; I-cache + I-burst
	movec	d0,CACR
	
	move.l	#wd_exit,glob_wdadr	; Watch dog address
	move.l	#vbi,$70.w		; the vbi routine
	
*	move.l	#20,glob_wdcnt	; Test watch dog if you want:-)
	
	move.b	MTYPE.w,d0		; Detect monitor type
	lsr.b	#6,d0
	tst.b	d0
	beq.w	exit
	cmp.b	#2,d0
	seq	glob_vga
	
	
	move.w	#25,d0		; SCREENS
	bsr.w	delay
	bsr.w	text	
	move.w	#75,d0
	bsr.w	delay
	
*	bsr.w	get_vb		; clear screen
*	move.l	(vblist,d0*4),a0
*	move.w	d0,d1
*	move.l	#320*240*2,d0
*	bsr.w	clr_mem
*	move.w	d0,d1
*	bsr.w	insert_vb
*	move.w	#25,d0
*	bsr.w	delay
	
	bsr.w	fire
	bsr.w	julia
	move.w	#25,d0
	bsr.w	delay
	
*	Crawcin

exit:	bsr.w	vb_sync
	bsr.w	restore_all
	Pterm0			; Exit

wd_exit:	bsr.w	vb_sync
	bsr.w	restore_all
	Cconws	#wd_exit_msg
	Crawcin
	Pterm0
	
	
****************************************
	
	include	misc\vsync.s
	include	misc\setvbase.s
	include	misc\multibuf.s
	include	misc\save.s
	include	misc\restore.s

	include	vidmodes\vidmodes.s
	
	include	e_text\text.s
	include	e_fire\fire.s
	include	e_julia\julia.s
	
****************************************

	
	section	text

; Hack for nice video mode switches
; in a6 address to video mode routine
	
new_video_mode:	
	movem.l	d0/d1/a0,-(sp)
	
	bsr.w	get_vb
	move.l	d0,d1
	
	lea	vblist(pc),a0
	move.l	(a0,d0.l*4),a0
	move.l	#(320*240),d0
	bsr	clr_mem
	
	move.l	d1,d0
	bsr.w	insert_vb
	bsr.w	vb_sync		; wait for queue to empty
	
	jsr	(a6)		; change video mode
	movem.l	(sp)+,d0/d1/a0
	rts
	

; in d0 number of bytes to clear
; in a0 memory..

clr_mem:	movem.l	a0/d0,-(sp)
.l00:	clr.b	(a0)+
	subq.l	#1,d0
	bhi	.l00
	movem.l	(sp)+,d0/a0
	rts	
	

; in d0 numer of vertical blanks to wait

delay:	subq.w	#1,d0
	blo	.exit
	bsr.w	vsync
	bra	delay
.exit	rts



****************************************

	section	data
	
wd_exit_msg:	dc.b	"Terminated by the watch dog, press a key ",13,0

	.long

	section	bss

save_vbi:	ds.l	1
save_vbase:	ds.l	1
save_videl:	ds.l	9
	
glob_vga:	ds.b	1		; Monitor type
	ds.b	3

scr1	ds.w	320*240
scr2	ds.w	320*240
scr3	ds.w	320*240
