#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <tos.h>


void rle_encode (char *image, short *b)
{
	char cc = 0; 
	int i;
	short rle_words = 0, rle_word = 1, *size;
	
	size = b++;
	
	for (i=0;i<16000;i++) {
		if (image[i] != cc) {
			cc = image[i];
			*b++ = rle_word;
			rle_word = 1;
			rle_words++;
		} else {
			rle_word++;
		}
	}
	*size = rle_words;
}


void rle_swap (short *b, char *b2)
{
	short size = *b++, i;
	
	*(short *)(b2) = size;
	b2+=2;
	
	for (i=0;i<size;i++)
		*b2++ = (char)(b[i] >> 8);
	
	for (i=0;i<size;i++)
		*b2++ = (char)b[i];
}


void main (int argc, char **argv)
{
	char *image;
	int fd;
	short *b, *b2;
	long slen;
	
	
	if (argc != 2)
		exit (-1);
	
	image = malloc (16000);
	b = malloc (32002);
	b2 = malloc (32002);
	
	fd = open (argv[1], O_RDONLY);
	if (fd == -1)
		exit (-1);
	
	lseek (fd, 788, SEEK_SET);
	read (fd, image, 16000);
	close (fd);
	
	rle_encode (image, b);
	rle_swap (b, (char *)b2);
	
	slen = strlen (argv[1]);
	argv[1][slen-1] = '_';
	
	fd = open (argv[1], O_WRONLY|O_CREAT|O_TRUNC);
	write (fd, b2, (*b2)*2+2);
}