	*****************************
	* SUBROUTINE GRAPHICS MAKER *
	*                           *
	* COYOTE 1996               *
	*****************************
	
	
; See use_sg.s for parameters
	
make_sg:
	movem.l	d0-a6,-(sp)
	lea	sg_script,a0		; Pointer to sg_script in a0
	bsr.w	get_number
	move.l	d0,sg_no_sprites
	
	lsl.l	#2,d0
	add.l	#sg_memory,d0
	move.l	#sg_memory,sg_cur_index_adr
	move.l	d0,sg_cur_sg_adr
	
	bsr.w	get_number
	add.l	d0,d0
	move.l	d0,sg_dx_source_in_bytes
	bsr.w	get_number
	add.l	d0,d0
	move.l	d0,sg_dx_dest_in_bytes
	
	
.j2:	lea	sg_sprite_info(pc),a1		; Get sprite info
	moveq	#7,d1
.j1:	bsr.w	get_number
	move.l	d0,(a1)+
	dbra	d1,.j1
	
	lea	sg_picture,a1
	move.l	a1,a3
	move.l	sg_sprite_y,d0
	mulu.l	sg_dx_source_in_bytes,d0
	add.l	d0,a1
	add.l	sg_sprite_x,a1
	add.l	sg_sprite_x,a1			; Start adress sprite
	move.l	a1,a2				; Save a1
	
	move.l	sg_mask_y,d0
	mulu.l	sg_dx_source_in_bytes,d0
	add.l	d0,a3
	add.l	sg_mask_x,a3
	add.l	sg_mask_x,a3			; Start adress mask
	move.l	a3,a4				; Save a3
	
	move.l	sg_cur_sg_adr,a5
	
	bsr.w	make_histogram			; Optimize with registers...
	bsr.w	get_mostly_used_colours
	
	move.l	sg_no_colours,d0		; Load registers...
	beq.s	.no_registers
	subq.l	#1,d0
	move.l	a0,-(sp)
	lea	sg_colours+2(pc),a0
	lea	sg_movel_1(pc),a6
.j5:	move.w	(a6),(a5)+
	move.w	(a0),(a5)+
	move.w	(a0),(a5)+
	move.w	(a0),-2(a0)
	addq.l	#4,a0
	addq.l	#8,a6
	dbra	d0,.j5
	move.l	(sp)+,a0
.no_registers:
	
	move.l	sg_hotspot_y,d3			; Adress offset in d3
	mulu.l	sg_dx_dest_in_bytes,d3
	add.l	sg_hotspot_x,d3
	add.l	sg_hotspot_x,d3
	neg.l	d3
	
	move.l	sg_dy,d0
	subq.l	#1,d0
.j3:	move.l	sg_dx,d1
	subq.l	#1,d1
	move.l	a2,a1				; Update sprite pointer
	move.l	a4,a3				; Update mask pointer

.j4:	tst.w	(a3)				; Test mask
	beq.s	.add_offset
	addq.l	#2,a1				; Increase sprite pointer by 2
	addq.l	#2,a3				; Increase mask pointer by 2
	addq.l	#2,d3				; Increase adress offset by 2
	dbra	d1,.j4
	bra.w	.new_line
	
.add_offset:
	tst.l	d3				; Add	#xxx,a0
	beq.s	.no_offset
	bpl.s	.positive_offset
	neg.l	d3
	bra.s	.negative_offset
	
.positive_offset:
	cmp.l	#8,d3
	bgt.s	.po1
	lea	sg_addq,a6
	move.w	(a6,d3.l),(a5)+
	clr.l	d3
	bra.s	.no_offset
.po1:	cmp.l	#32767,d3
	bgt.s	.po2
	move.w	sg_addaw,(a5)+
	move.w	d3,(a5)+
	clr.l	d3
	bra.s	.no_offset
.po2:	move.w	sg_addal,(a5)+
	move.l	d3,(a5)+
	clr.l	d3
	bra.s	.no_offset
	
.negative_offset:
	cmp.l	#8,d3
	bgt.s	.no1
	lea	sg_subq,a6
	move.w	(a6,d3.l),(a5)+
	clr.l	d3
	bra.s	.no_offset
.no1:	cmp.l	#32767,d3
	bgt.s	.no2
	move.w	sg_subaw,(a5)+
	move.w	d3,(a5)+
	clr.l	d3
	bra.s	.no_offset
.no2:	move.w	sg_subal,(a5)+
	move.l	d3,(a5)+
	clr.l	d3
	
.no_offset:
	tst.w	d1				; Is it possible to use a long word? ($ff=word $00=long word)
	seq	d4
	beq.s	.word_xn
	tst.w	2(a3)
	sne	d4
	
.long_word_xn
	tst.b	d4
	bne.s	.word_xn
	move.l	sg_no_colours,d5
	beq.s	.long_word_im			; Jump if no registers contain colour information
	subq.l	#1,d5
	move.l	(a1),d6
	lea	sg_colours(pc),a6
.j6:	cmp.l	(a6,d5.l*4),d6
	bne.s	.j7
	lea	sg_movel_2(pc),a6
	move.w	(a6,d5.l*2),(a5)+		; Place instuction in sg
	addq.l	#4,a1				; Increase sprite and mask pointers
	addq.l	#4,a3
	subq.l	#1,d1				, 2 pixels!
	dbra	d1,.j4
	bra.s	.new_line
.j7	dbra	d5,.j6
	
.word_xn:	
	move.l	sg_no_colours,d5
	beq.s	.long_word_im
	subq.l	#1,d5
	move.w	(a1),d6
	lea	sg_colours(pc),a6
.j8:	cmp.w	(a6,d5.l*4),d6
	bne.s	.j9
	lea	sg_movew_2(pc),a6
	move.w	(a6,d5.l*2),(a5)+
	addq.l	#2,a1				; Increase sprite and mask pointers
	addq.l	#2,a3
	dbra	d1,.j4
	bra.s	.new_line
.j9	addq.l	#4,a6
	dbra	d5,.j8

.long_word_im:
	tst.b	d4
	bne.s	.word_im
	move.w	sg_movel,(a5)+
	move.l	(a1)+,(a5)+
	addq.l	#4,a3
	subq.l	#1,d1				; 2 pixels!
	dbra	d1,.j4
	bra.s	.new_line
	
.word_im:
	move.w	sg_movew,(a5)+
	move.w	(a1)+,(a5)+
	addq.l	#2,a3
	dbra	d1,.j4
	
	
.new_line:
	add.l	sg_dx_source_in_bytes,a2	; Increase sprites pointer
	add.l	sg_dx_source_in_bytes,a4	; Increase mask pointer
	move.l	sg_dx_dest_in_bytes,d2
	sub.l	sg_dx,d2
	sub.l	sg_dx,d2
	add.l	d2,d3
	dbra	d0,.j3
	
	move.w	sg_rts,(a5)+			; Terminate subroutine
	
	move.l	sg_cur_index_adr,a1		; Index to subroutine
	move.l	sg_cur_sg_adr,(a1)
	addq.l	#4,sg_cur_index_adr
	
	move.l	a5,sg_cur_sg_adr		; Save new start adress for sg
	subq.l	#1,sg_no_sprites
	bgt.w	.j2
		
.exit	movem.l	(sp)+,d0-a6
	rts
	
	
	
	
; In  a1 Pointer to sprite
; In  a2 Pointer to sprite
; In  a3 Pointer to mask
; In  a4 Pointer to mask
	
make_histogram:
	movem.l	d0-a6,-(sp)
	
	lea	sg_histogram,a0			; Clear histogram
	move.w	#8191,d0
	clr.l	d1
.j1:	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	move.l	d1,(a0)+
	dbra	d0,.j1
	
	lea	sg_histogram,a0
	clr.l	d2
	move.l	sg_dy,d0
	subq.l	#1,d0
.j2:	move.l	sg_dx,d1
	subq.l	#1,d1
	move.l	a2,a1
	move.l	a4,a3

.j3:	move.w	(a1)+,d2
	tst.w	(a3)+
	bne.s	.no_pixel
	addq.w	#1,(a0,d2.l*2)
.no_pixel:
	dbra	d1,.j3
	add.l	sg_dx_source_in_bytes,a2	; Increase sprites pointer
	add.l	sg_dx_source_in_bytes,a4	; Increase mask pointer
	dbra	d0,.j2	
	
	movem.l	(sp)+,d0-a6
	rts
	
	
	

get_mostly_used_colours:
	movem.l	d0-a6,-(sp)
	
	lea	sg_colours(pc),a0	; Clear colour table
	move.l	a0,a1
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	
	lea	sg_histogram,a0
	move.l	#65535,d0

.j1:	move.w	(a0,d0.l*2),d1
	cmp.w	3*4(a1),d1
	ble.s	.to_few
	
	move.w	d1,3*4(a1)		; Number of pixels with the colour in d0
	move.w	d0,3*4+2(a1)	; Colour
	
.not_sorted:				; Bouble sort the colour table
	lea	sg_colours(pc),a2
	lea	sg_colours+4(pc),a3
	moveq	#2,d1

.next:	move.w	(a3),d2
	cmp.w	(a2),d2
	ble.s	.continue
	
	move.l	(a2),d1			; Swap colours
	move.l	(a3),(a2)
	move.l	d1,(a3)
	bra.s	.not_sorted

.continue:
	addq.l	#4,a2
	addq.l	#4,a3
	dbra	d1,.next
	
.to_few:
	dbra	d0,.j1
	
	clr.l	sg_no_colours		; How many colours is used in more than 3 pixels?
	moveq	#3,d0
.j3:	cmpi.w	#4,(a1)			; #sg_colours in a1
	bmi.s	.j4
	addq.l	#1,sg_no_colours
.j4:	addq.l	#4,a1
	dbra	d0,.j3
	
	movem.l	(sp)+,d0-a6
	rts
	
	
	
	
; In  a0 Pointer to ascii number
; Out d0 Number
; Out a0 Pointer to next ascii number
	
get_number:
	movem.l	d1-d3/a1,-(sp)
	clr.l	d1
	clr.l	d2
.j1:	move.b	(a0)+,d1
	cmpi.b	#9,d1
	beq.s	.convert
	cmpi.b	#10,d1
	beq.s	.convert
	cmpi.b	#13,d1
	beq.s	.convert_atari
	
	subi.b	#48,d1
	lsl.l	#4,d2
	or.l	d1,d2
	bra.s	.j1
	
.convert_atari
	addq.l	#1,a0
.convert:
	clr.l	d0
	moveq	#7,d3
	lea	decimal_table(pc),a1
.j2:	move.l	d2,d1
	andi.l	#$f,d1
	mulu.l	(a1)+,d1
	add.l	d1,d0
	lsr.l	#4,d2
	dbra	d3,.j2
	movem.l	(sp)+,d1-d3/a1
	rts
	
	
	
	
	**** GUNK DATA ****
		
sg_movel_1:	move.l	#$cccccccc,d0
		nop
		move.l	#$cccccccc,d1
		nop
		move.l	#$cccccccc,d2
		nop
		move.l	#$cccccccc,a1
		nop

sg_movew_2:	move.w	d0,(a0)+
		move.w	d1,(a0)+
		move.w	d2,(a0)+
		move.w	a1,(a0)+
		
sg_movel_2:	move.l	d0,(a0)+
		move.l	d1,(a0)+
		move.l	d2,(a0)+
		move.l	a1,(a0)+
		
sg_movew:	move.w	#$cccc,(a0)+
sg_movel:	move.l	#$cccccccc,(a0)+
		
sg_addq:	nop
		addq.l	#2,a0
		addq.l	#4,a0
		addq.l	#6,a0
		addq.l	#8,a0
		
sg_subq:	nop
		subq.l	#2,a0
		subq.l	#4,a0
		subq.l	#6,a0
		subq.l	#8,a0
		
sg_addaw:	adda.w	#$cccc,a0	
sg_addal:	adda.l	#$cccccccc,a0
		
sg_subaw:	suba.w	#$cccc,a0	
sg_subal:	suba.l	#$cccccccc,a0
		
sg_rts:		rts
		
decimal_table:	dc.l	1,10,100,1000,10000,100000,1000000,10000000
		
		
	**** GUNK VARIABLES ****
	cnop	0,4

sg_no_colours:		ds.l	1
sg_colours:		ds.l	4	; The 4 mostly used colours in the sprite

sg_pointers:	
sg_cur_index_adr:	ds.l	1
sg_cur_sg_adr:		ds.l	1

sg_header:
sg_no_sprites:		ds.l	1
sg_dx_source_in_bytes:	ds.l	1
sg_dx_dest_in_bytes:	ds.l	1

sg_sprite_info:
sg_sprite_x:		ds.l	1
sg_sprite_y:		ds.l	1
sg_mask_x:		ds.l	1
sg_mask_y:		ds.l	1
sg_dx:			ds.l	1
sg_dy:			ds.l	1
sg_hotspot_x:		ds.l	1
sg_hotspot_y:		ds.l	1